# -*- coding: utf-8 -*-
"""
Created on Fri Jan 21 00:09:10 2022

@author: LENOVO
"""


import re


def neighbourhood_words(keyword, text, left, right):
    text = text.upper()
    keyword = keyword.upper()
    text_pieces = text.split(keyword)

    if len(text_pieces) == 1:
        return None

    split_words = [piece.split() for piece in text_pieces]
    occurences = []

    for index in range(len(split_words) - 1):
        left_words = split_words[index][len(split_words[index]) - left:]
        right_words = split_words[index + 1][0: right]
        surrounded_text = " ".join(left_words + [keyword] + right_words)
        occurences.append(surrounded_text)

    return occurences


def left_texts(keyword, text):
    text = text.upper()
    keyword = keyword.upper()
    text_pieces = text.split(keyword)

    if len(text_pieces) == 1:
        return None
    
    return text_pieces[0]


def right_texts(keyword, text):
    text = text.upper()
    keyword = keyword.upper()
    text_pieces = text.split(keyword)

    if len(text_pieces) == 1:
        return None
    
    return text_pieces[1]


def keyword_position(keyword, text):
    keyword = keyword.upper()
    text = text.upper()
    key = re.finditer(keyword, text)
    pos_start_end = [(match.start(),match.end()) for match in key]
    return pos_start_end


def neighbourhood_chr(keyword, text, left_chr, right_chr):
    keyword = keyword.upper()
    text = text.upper()

    key = re.finditer(keyword, text)
    pos_start_end = [(match.start(),match.end()) for match in key]
    need = []
    for pos in pos_start_end:
        user_need = text[pos[0]-left_chr : pos[1]+right_chr]
        need.append(user_need)
    return need


def dataframe_keyword_remover(remover_list, dataframe, replaced_by):
    pattern = '|'.join([r'{}'.format(w) for w in remover_list])
    output_df = dataframe.replace(pattern, replaced_by, regex=True)
    return output_df


def text_keyword_remover(remover_list, text, replaced_by):
    pattern = re.compile('|'.join(map(re.escape, remover_list)))
    output = pattern.sub(replaced_by, text)
    return output






